;----------------------------------------
DLX050	DC.L	DLX049
	DC.B	6,'NEGATE',0	;NEGATE
	DC.W	MACRO+1
NEGATE	NEG.L	(A6)
	RTS
;-----------------------------------------
DLX051	DC.L	DLX050
	DC.B	1,'-',0,0,0,0,0,0	;-
	DC.W	MACRO+2
	MOVE.L	(A6)+,D0
	SUB.L	D0,(A6)
	RTS
******************************************
*          ARITHMETIC ROUTINES           *
******************************************
;---- ROUTINE USED BY DIV AND MOD, SLOW BUT SMALL
DIVX	MOVE.L	(A6)+,D6	;GET DIVISOR
	MOVE.L	D6,D1		;COPY FOR SIGN
	BPL.S	DIV020		;OK IF +
	NEG.L	D6		;MAKE +
DIV020	MOVE.L	(A6)+,D5	;GET DIVIDEND
	MOVE.L	D5,D0		;COPY FOR SIGN
	BPL.S	DIV040		;OK IF +
	NEG.L	D5		;MAKE +
DIV040	MOVEQ	#0,D4		;CLEAR WORK
;------- DIVIDE 64 BITS BY 32 BITS D4:D5 / D6
DIV100	MOVEQ	#32,D3		;COUNT =32 BITS
DIV200	MOVE	#0,CCR		;CLEAR EXTEND
	CMP.L	D6,D4		;IF DVDND < DVSR
	BLO.S	DIV300		;NO ACTION
	SUB.L	D6,D4		;SUB DVSR
	MOVE	#$10,CCR	;SET QUOTIENT BIT
DIV300	ADDX.L	D5,D5		;SHFT LEFT DIVIDEND
	ADDX.L	D4,D4		;AND QUOT 64 BITS
	DBRA	D3,DIV200	;LOOP 32 TIMES
	MOVEQ	#0,D6		;CLEAR D6
	RTS
********************************************************
DLX052	DC.L	DLX051
	DC.B	1,'*',0,0,0,0,0,0	;* ---- MULTIPLY
	DC.W	0
MULT	MOVE.W	2(A6),D0
	MULU	4(A6),D0	;B * C
	MOVE.W	(A6),D1
	MULU	6(A6),D1	;A * D
	ADD.L	D0,D1		;SUM
	SWAP	D1		;PUT IN LEFT
	CLR.W	D1		;CLEAR RIGHT
	MOVE.L	(A6)+,D0	;GET & MOVE PNTR
	MULU	2(A6),D0	;B * D
	ADD.L	D1,D0		;ADD HIGH PARTS
	MOVE.L	D0,(A6)	;PUT BACK
	RTS
;-----------------------------------------
DLX053	DC.L	DLX052
	DC.B	1,'/',0,0,0,0,0,0	;/ --------- DIVIDE
	DC.W	0
DIV	BSR	DIVX		;CRUNCH NUMBERS
DIV800	EOR.L	D0,D1		;SEE IF SIGNS ARE SAME
	BPL.S	DIV900		;IF PLUS, WERE SAME
	NEG.L	D5		;NEGATE QUOT
DIV900	MOVE.L	D5,-(A6)	;SAVE QUOTIENT
	RTS
;-----------------------------------------
DLX054	DC.L	DLX053
	DC.B	3,'MOD',0,0,0,0	;MOD ---------- REMAINDER
	DC.W	0
MOD	BSR	DIVX		;DO DIVISION
	LSR.L	#1,D4		;CORRECT REMAINDER
	TST.L	D0		;CHECK DIVIDEN SIGN
	BPL.S	MOD100		;PLUS NEEDS NO CHANGE
	NEG.L	D4		;NEGATE REM
MOD100	MOVE.L	D4,-(A6)	;SAVE REM
	RTS
;-----------------------------------------
DLX055	DC.L	DLX054
	DC.B	4,'/MOD',0,0,0	;/MOD
	DC.W	0
	BSR	MOD		;REM
	BSR	DIV800		;QUOT
	RTS
*******************************************************
;---- */ MULT AND DIVIDE, 64 BIT IMTERMEDIATE
MDIV	MOVE.L	(A6)+,D6	;GET DIVISOR
	MOVE.L	D6,D2		;SAVE FOR SIGN
	BPL.S	MDV020		;OK IF +
	NEG.L	D6		;MAKE +
MDV020	TST.W	(A6)		;CHECK FACTOR
	BPL.S	MDV040
	NEG.L	(A6)		;MAKE +
	NOT.L	D2		;FIX SIGN
MDV040	TST.W	4(A6)		;CHECK OTHER FACTOR
	BPL.S	MDV060
	NEG.L	4(A6)		;MAKE +
	NOT.L	D2		;FIX SIGN
MDV060	MOVE.W	4(A6),D4	;CREATE 64 BIT PRODUCT
	MULU	(A6),D4		;HI * HI
	MOVE.W	2(A6),D5
	MULU	6(A6),D5	;LO * LO
	MOVE.W	(A6),D0
	MULU	6(A6),D0	;HA * LB
	MOVE.W	2(A6),D1
	MULU	4(A6),D1	;LB * HA
	ADD.L	D0,D1		;SET X BIT
	BCC.S	MDV100		;TAKE CARE OF CARRY
	ADDI.L	#$10000,D4	;IN HIGHEST WORD
MDV100	MOVE.L	D1,D0		;COPY
	SWAP	D0
	CLR.W	D0		;LOW HALF
	CLR.W	D1
	SWAP	D1
	ADD.L	D0,D5		;LOW 32 BITS
	ADDX.L	D1,D4		;HIGH 32 BIS
	MOVE.L	(A6)+,D0	;CALC MOD SIGN
	MOVE.L	(A6)+,D1
	EOR.L	D1,D0		;HAS REM SIGN
	BSR	DIV100		;DIVIDE IT
	TST.L	D2		;CHECK THE SIGN
	BPL.S	MDV200		;OK IF +
	NEG.L	D5		;NEGATE IT, FORGET REM
MDV200	RTS			;GO HOME
*******************************************************
DLX056	DC.L	DLX055
	DC.B	2,'*/',0,0,0,0,0	;*/
	DC.W	0     
	BSR	MDIV    
	MOVE.L	D5,-(A6)	;QUOT
	RTS
;-----------------------------------------
DLX057	DC.L	DLX056
	DC.B	5,'*/MOD',0,0	;*/MOD
	DC.W	0
	BSR	MDIV
	LSR.L	#1,D4		;CORRET REM   
	TST.L	D0		;CHECK SIGN
	BPL.S	MDV900
	NEG.L	D4
MDV900	MOVE.L	D4,-(A6)	;REM
	MOVE.L	D5,-(A6)	;QUOT
	RTS
;-----------------------------------------
DLX058	DC.L	DLX057
	DC.B	1,'>',0,0,0,0,0,0	;>
	DC.W	0       
	MOVE.L	(A6)+,D0
	CMP.L	(A6),D0
	BLT	DTRUE
DFALSE	CLR.L	(A6)
	RTS
;-----------------------------------------
DLX059	DC.L	DLX058
	DC.B	1,'<',0,0,0,0,0,0	;<
	DC.W	0
	MOVE.L	(A6)+,D0
	CMP.L	(A6),D0
	BLE	DFALSE
DTRUE	MOVEQ	#-1,D0
	MOVE.L	D0,(A6)
	RTS
;-----------------------------------------
DLX060	DC.L	DLX059
	DC.B	3,'KEY',0,0,0,0	;KEY
	DC.W	0
KEY	LEA	NBUF(A5),A0	;USE NBUF
	MOVE.L	A0,PBLK1+10(A5)	;BUFADRS
	MOVE.W	#2,PBLK1(A5)	;CMD= READ
	CLR.W	PBLK1+2(A5)	;CLEAR STATUS FOR DEBUG
	MOVE.W	#1,PBLK1+4(A5)	;CHANNEL= 1 (CONSOLE)
	MOVE.W	#1,PBLK1+6(A5)	;MAX COUNT
	LEA	PBLK1(A5),A0
	BSR	TRAP2		;SEND AND WAIT
	CLR.L	D0		;GET BYTE READ
	MOVE.B	NBUF(A5),D0
	MOVE.L	D0,-(A6)
	RTS			;BACK TO USER
;-----------------------------------------
DLX061	DC.L	DLX060
	DC.B	4,'EMIT',0,0,0	;EMIT
	DC.W	0
EMIT	MOVE.L	(A6)+,D0	;PRINT A SINGLE BYTE
PUTD0	LEA	NBUF(A5),A0	;USE NBUF
	MOVE.B	D0,(A0)		;PUT BYTE THERE
	MOVEQ	#1,D0		;COUNT=1
	BRA	APR100		;SEND IT
;-----------------------------------------
DLX062	DC.L	DLX061
	DC.B	2,',W',0,0,0,0,0	;COMMA WORD
	DC.W	0                          
WCOMA	MOVEA.L	DICT(A5),A1
	MOVE.L	(A6)+,D0
	MOVE.W	D0,(A1)+
	MOVE.L	A1,DICT(A5)
	RTS
;-----------------------------------------
DLX063	DC.L	DLX062
	DC.B	1,'@',0,0,0,0,0,0	;@ LOAD
	DC.W	MACRO+2
	MOVEA.L	(A6),A0
	MOVE.L	(A0),(A6)
	RTS
;-----------------------------------------
DLX064	DC.L	DLX063
	DC.B	4,'FILL',0,0,0 	;FILL
	DC.W	0      
	MOVE.L	(A6)+,D0	;CHAR
FILL	MOVE.L	(A6)+,D1	;COUNT
	MOVEA.L	(A6)+,A0	;ADRS
FIL020	MOVE.B	D0,(A0)+
	SUBQ.L	#1,D1 		;FILL SIZE
	BNE	FIL020
	RTS
;-----------------------------------------
DLX065	DC.L	DLX064
	DC.B	2,'BL',0,0,0,0,0	;BL
	DC.W	0                  
	MOVE.L	#32,D0
	MOVE.L	D0,-(A6)
	RTS
;-----------------------------------------
DLX066	DC.L	DLX065
	DC.B	5,'BLANK',0,0	;BLANK
	DC.W	0      
	MOVEQ	#32,D0
	BRA	FILL
;-----------------------------------------
DLX067	DC.L	DLX066
	DC.B	5,'ERASE',0,0	;ERASE
	DC.W	0      
	MOVEQ	#0,D0
	BRA	FILL
;-----------------------------------------
DLX068	DC.L	DLX067
	DC.B	4,'BASE',0,0,0	;BASE
	DC.W	0
BASECOD	LEA	BASE(A5),A0	;PUSH ADRS
	MOVE.L	A0,-(A6)
	RTS
;-----------------------------------------
DLX069	DC.L	DLX068
	DC.B	1,'!',0,0,0,0,0,0	;! STORE
	DC.W	MACRO+2
	MOVEA.L	(A6)+,A0
	MOVE.L	(A6)+,(A0)
	RTS
;-----------------------------------------
DLX070	DC.L	DLX069
	DC.B	1,'=',0,0,0,0,0,0	;=
	DC.W	0                
	MOVE.L	(A6)+,D0
	CMP.L	(A6)+,D0
	BEQ	TRUE
	BRA	FALSE
;-----------------------------------------
DLX071	DC.L	DLX070
	DC.B	3,'HEX',0,0,0,0	;HEX
	DC.W	0
	MOVEQ	#16,D0
	MOVE.L	D0,BASE(A5)
	RTS
;-----------------------------------------
DLX072	DC.L	DLX071
	DC.B	7,'DECIMAL'	;DECIMAL
	DC.W	0         
DECMAL	MOVEQ	#10,D0
	MOVE.L	D0,BASE(A5)
	RTS
;-----------------------------------------
DLX073	DC.L	DLX072
	DC.B	4,'SWAP',0,0,0	;SWAP
	DC.W	0
SWAP	MOVE.L	(A6)+,D1
	MOVE.L	(A6),D0
	MOVE.L	D1,(A6)
	MOVE.L	D0,-(A6)
	RTS
;-----------------------------------------
DLX074	DC.L	DLX073
	DC.B	3,'DUP',0,0,0,0	;DUP
	DC.W	MACRO+1
	MOVE.L	(A6),-(A6)
	RTS
;-----------------------------------------
DLX075	DC.L	DLX074
	DC.B	3,'ABS',0,0,0,0	;ABS
	DC.W	0
ABS	TST.L	(A6)
	BPL.S	ABS010
	NEG.L	(A6)
ABS010	RTS
;-----------------------------------------
DLX076	DC.L	DLX075
	DC.B	4,'DROP',0,0,0	;DROP
	DC.W	MACRO+1
	ADDQ.L	#4,A6
	RTS
;-----------------------------------------
DLX077	DC.L	DLX076
	DC.B	4,'OVER',0,0,0	;OVER
	DC.W	0
	MOVE.L	4(A6),-(A6)
	RTS
;-----------------------------------------
DLX078	DC.L	DLX077
	DC.B	4,'2DUP',0,0,0	;2DUP
	DC.W	0
	MOVE.L	4(A6),-(A6)	;OVER OVER
	MOVE.L	4(A6),-(A6)
	RTS
;-----------------------------------------
DLX079	DC.L	DLX078
	DC.B	5,'ASCII',0,0	;ASCII
	DC.W	IMMED
XX079AA	BSR	GETCX		;GET CHARS
	CMPI.B	#' ',D0		;IGNORE SPACES
	BEQ	XX079AA		;UNTIL NOT SPACE
	MOVEA.L	DICT(A5),A1
	MOVE.W	#$2D3C,(A1)+	;MOVE.L	#XX,-(A6)
	MOVE.L	D0,(A1)+	;COMPILE VALUE
	MOVE.L	A1,DICT(A5)
	RTS			;END OF WORD
;-----------------------------------------
DLX080	DC.L	DLX079
	DC.B	4,'TRUE',0,0,0
	DC.W	MACRO+2
TRUE	MOVEQ	#-1,D0		;SET RESULT TRUE
	MOVE.L	D0,-(A6)
	RTS             
;-----------------------------------------
DLX081	DC.L	DLX080
	DC.B	5,'FALSE',0,0
	DC.W	MACRO+1
FALSE	CLR.L	-(A6)		;SET RESULT FALSE
	RTS	
;------ CHECK RANGE  ( item  low  high -- torf )
DLX082	DC.L	DLX081
	DC.B	5,'RANGE',0,0
	DC.W	0
RANGE	MOVE.L	(A6)+,D0	;HIGH
	MOVE.L	(A6)+,D1	;LOW
	MOVE.L	(A6),D2		;ITEM
	CLR.L	(A6)		;ASSUME FALSE
	CMP.L	D1,D2		;COMP LOW
	BLT.S	RNG100		;GOTO FALSE
	CMP.L	D0,D2		;TEST HIGH
	BGT.S	RNG100		;GOTO FALSE
	NOT.L	(A6)		;RETURN TRUE
RNG100	RTS             
;------------------------------------------
DLX083	DC.L	DLX082
	DC.B	2,'>R',0,0,0,0,0	;>R
	DC.W	0
	MOVEA.L	(A7)+,A0
	MOVE.L	(A6)+,-(A7)
	JMP	(A0)		;RTS
;----------------------------------
DLX084	DC.L	DLX083
	DC.B	1,'I',0,0,0,0,0,0	;I  COPY TOP RTN
	DC.W	0
	MOVE.L	4(A7),-(A6)
	RTS
;----------------------------------
DLX085	DC.L	DLX084
	DC.B	2,"I'",0,0,0,0,0	;I' COPY SECOND
	DC.W	0
	MOVE.L	8(A7),-(A6)
	RTS
;----------------------------------
DLX086	DC.L	DLX085
	DC.B	1,'J',0,0,0,0,0,0	;J  COPY THIRD
	DC.W	0
	MOVE.L	12(A7),-(A6)
	RTS             
;----------------------------------
DLX087	DC.L	DLX086
	DC.B	1,'[',0,0,0,0,0,0	; [ STOP COMPILE
	DC.W	IMMED
	CLR.L	STATE(A5)
	RTS
;----------------------------------
DLX088	DC.L	DLX087
	DC.B	1,']',0,0,0,0,0,0	; ] START COMPILE
	DC.W	MACRO+2
	ST	STATE(A5)
	RTS
;----------------------------------
DLX089	DC.L	DLX088
	DC.B	4,'HERE',0,0,0	;HERE
	DC.W	MACRO+2
	MOVE.L	DICT(A5),-(A6)
	RTS
*************************************************
*            FILE I/O ROUTINES                  *
*************************************************
DLX090	DC.L	DLX089
	DC.B	7,'OPENFIL'	;OPENFIL ( ADRS - CHAN)
	DC.W	0
OPENFIL	LEA	PBLK1(A5),A1
	MOVE.W	#5,(A1)+	;CMD
	CLR.W	(A1)+		;STAT
	CLR.W	(A1)+		;CHANNEL
	MOVEA.L	(A6)+,A0	;ADRS
	MOVEQ	#0,D0
	MOVE.B	(A0)+,D0	;GET & SKIP COUNT
	MOVE.L	A0,(A1)		;PUT IN PATHNAME
	CLR.B	0(A0,D0)	;MAKE ASCIZ
	LEA	PBLK1(A5),A0
	BSR	TRAP2		;USE SYSTEM TRAP
	MOVEQ	#0,D0
	MOVE.W	4(A0),D0	;TRAP KEEPS A0
	MOVE.L	D0,-(A6)	;GET CHANNEL
	RTS
;-------------------------------------------------
DLX091	DC.L	DLX090
	DC.B	6,'MAKFIL',0	;MAKFIL  ( ADRS - CHAN )
	DC.W	0
MAKFIL	LEA	PBLK1(A5),A1
	MOVE.W	#6,(A1)+	;CMD
	CLR.W	(A1)+		;STAT
	MOVEA.L	(A6)+,A0	;ADRS
	MOVEQ	#0,D0
	MOVE.B	(A0)+,D0	;GET & SKIP COUNT
	MOVE.L	A0,(A1)		;PUT IN PATHNAME
	CLR.B	0(A0,D0)	;MAKE ASCIZ
	LEA	PBLK1(A5),A0
	BSR	TRAP2		;USE SYSTEM TRAP
	MOVEQ	#0,D0
	MOVE.W	2(A0),D0	;TRAP SAVES A0
	MOVE.L	D0,-(A6)	;GET STATUS
	RTS
;-------------------------------------------------
DLX092	DC.L	DLX091
	DC.B	7,'READFIL'	;READFIL ( CHAN BUF SIZE -- READ )
	DC.W	0
READFIL	LEA	PBLK1(A5),A1	;          +8   +4  +0
	MOVE.W	#2,(A1)+	;CMD
	CLR.W	(A1)+		;STAT
	MOVE.L	8(A6),D0	;GET CHAN 
	MOVE.W	D0,(A1)+
	MOVE.L	(A6)+,D0
	MOVE.W	D0,(A1)+	;REQUEST SIZE
	CLR.W	(A1)+		;ACTUAL READ
	MOVE.L	(A6)+,(A1)	;BUFFER
	ADDQ.L	#4,A6		;DROP CHAN
	LEA	PBLK1(A5),A0
	BSR	TRAP2		;USE SYSTEM TRAP
	MOVEQ	#0,D0
	MOVE.W	8(A0),D0	;TRAP SAVES A0
	MOVE.L	D0,-(A6)	;GET COUNT
	RTS
;-------------------------------------------------
DLX093	DC.L	DLX092
	DC.B	7,'WRITFIL'	;WRITFIL ( CHAN BUF SIZE -- WROTE )
	DC.W	0
WRITFIL	LEA	PBLK1(A5),A1
	MOVE.W	#3,(A1)+	;CMD
	CLR.W	(A1)+		;STAT
	MOVE.L	8(A6),D1	;CHAN
	MOVE.W	D1,(A1)+
	MOVE.L	(A6)+,D0
	MOVE.W	D0,(A1)+	;SIZE
	CLR.W	(A1)+
	MOVE.L	(A6)+,(A1)+	;BUFFER
	ADDQ.L	#4,A6		;DROP CHAN
	LEA	PBLK1(A5),A0
	BSR	TRAP2		;USE SYSTEM TRAP
	MOVEQ	#0,D0
	MOVE.W	2(A0),D0	;TRAP SAVES A0
	MOVE.L	D0,-(A6)	;GET COUNT
	RTS
;-------------------------------------------------
DLX094	DC.L	DLX093
	DC.B	7,'SEEKFIL'	;SEEKFIL ( CHAN POS -- )
	DC.W	0
SEEKFIL	LEA	PBLK1(A5),A1
	MOVE.W	#4,(A1)+	;CMD
	CLR.W	(A1)+		;STAT
	MOVE.L	(A6)+,(A1)+	;POSITION
	MOVE.L	(A6)+,D0
	MOVE.W	D0,(A1)+	;CHAN
	LEA	PBLK1(A5),A0
	BSR	TRAP2		;USE SYSTEM TRAP
	MOVEQ	#0,D0
	MOVE.W	2(A0),D0	;TRAP SAVES A0
	MOVE.L	D0,-(A6)	;GET COUNT
	RTS
;-------------------------------------------------
DLX095	DC.L	DLX094
	DC.B	7,'CLOSFIL'	;CLOSFIL ( CHAN -- )
	DC.W	0
CLOSFIL	LEA	PBLK1(A5),A1
	MOVE.W	#8,(A1)+	;CMD
	CLR.W	(A1)+		;STAT
	MOVE.L	(A6)+,D0
	MOVE.W	D0,(A1)+	;CHAN
	LEA	PBLK1(A5),A0
	BSR	TRAP2		;USE SYSTEM TRAP
	MOVEQ	#0,D0
	MOVE.W	2(A0),D0	;TRAP SAVES A0
	MOVE.L	D0,-(A6)	;GET COUNT
	RTS
;-----------------------------------------
DLX096	DC.L	DLX095
	DC.B	6,'PARBLK',0	;PARBLK -- CONSTANT
	DC.W	0
	LEA	PBLK1(A5),A0	;ADRES OF SYSTEM PARAM BLK
	MOVE.L	A0,-(A6)
	RTS     
;-----------------------------------------
DLX097	DC.L	DLX096
	DC.B	4,'CODE',0,0,0	;CODE
	DC.W	IMMED
CODE	MOVE.W	#16,BASE+2(A5)	;HEX BASE
	TAS	FCODE(A5)	;SET CODE FLAG
	RTS      
;-----------------------------------------
DLX098	DC.L	DLX097
	DC.B	3,'REL',0,0,0,0	;REL
	DC.W	MACRO+3
	MOVE.L	(A6)+,D0
	SUB.L	A5,D0
	MOVE.L	D0,-(A6)
	RTS
;-----------------------------------------
DLX099	DC.L	DLX098
	DC.B	5,'UNREL',0,0	;UNREL
	DC.W	MACRO+3
	MOVE.L	(A6)+,D0
	ADD.L	A5,D0
	MOVE.L	D0,-(A6)
	RTS                              
;-------------------------------------------
	END

