( SAMPLE FORTH LOAD PROGRAM )
: DOLLAR <S# # # 46 HOLD #S SSIGN 36 HOLD #> TYPE SPACE ;
: NBLANK DUP PAD OVER - SWAP BLANK ;
: .R  NBLANK SWAP <S# #S SSIGN #> 2DROP
  PAD OVER - SWAP TYPE ;
: U. <# #S #> TYPE SPACE ;
: U.R ( UNSIGNED .R )
  NBLANK SWAP <# #S #> 2DROP
  PAD OVER - SWAP TYPE ;
: ?  @ BASE @ SWAP DECIMAL . BASE ! ;
: .H  @ BASE @ SWAP HEX . BASE ! ;
: 0<>  0= NOT ;
: <= > NOT ;
: >= < NOT ;
: <> = NOT ;              
: MAX 2DUP < IF NIP ELSE DROP ENDIF ;
: MIN 2DUP < IF DROP ELSE NIP ENDIF ;
  VARIABLE >IN
: QUERY
  TIB 80 EXPECT 0 >IN ! ;
( FORTH MEMORY DUMP PROGRAM )
: .2  <# # # #> TYPE SPACE ; ( TWO DIGIT DISPLAY )
: SPACES 0 DO SPACE LOOP ;
: D.2  ( ADDR LEN )
  BOUNDS DO I @B .2 LOOP ;
: BETWEEN RANGE ; ( NEW NAME )
: EMIT.  ( CHAR -- ) ( EMIT IF PRINTABLE )
  127 AND DUP BL 126 BETWEEN
  NOT IF DROP ( ASCII .) 46  ENDIF EMIT ;
: DLN ( ADR -- ) ( DISPLAY LINE )
  CR
  DUP 8 .R 2 SPACES
  8 2DUP D.2 SPACE
  OVER + 8 D.2 SPACE
  16 BOUNDS DO I @B EMIT. LOOP ;
: ?.N  ( N1 N2 -- N1 )
  2DUP =
  IF ." \/" DROP
  ELSE 2 .R ENDIF
  SPACE ;
: ?.A
  2DUP =
  IF ." V" DROP
  ELSE 1 .R ENDIF ;
: .HEAD
  SWAP DUP 16 NEGATE AND
  SWAP 15 AND  CR 10 SPACES
  8  0 DO I ?.N LOOP  SPACE
  16 8 DO I ?.N LOOP  SPACE
  16 0 DO I ?.A LOOP
  ROT + ;
: DUMP
  BASE @ -ROT HEX .HEAD
  BOUNDS DO I DLN
   ( KEY? ?LEAVE ) 16 +LOOP BASE ! ;
: DU
  DUP 64 DUMP 64 + ;

QUIT
ABORT
;


